Main Page | Modules | Alphabetical List | Data Structures | File List | Data Fields | Globals

# uip/uip.h File Reference

## Detailed Description

Header file for the uIP TCP/IP stack.

Author:
  Adam Dunkels <adam@dunkels.com>

The uIP TCP/IP stack header file contains definitions for a number of C macros that are used by uIP programs as well as internal uIP structures, TCP/IP header structures and function declarations.

`#include "uipopt.h"`

Include dependency graph for uip.h:

This graph shows which files directly or indirectly include this file:

## Data Structures
struct | uip_conn
| Representation of a uIP TCP connection. More...
struct | uip_stats
| The structure holding the TCP/IP statistics that are gathered if UIP_STATISTICS is set to 1. More...
struct | uip_udp_conn
| Representation of a uIP UDP connection. More...
## Defines
#define | uip_sethostaddr(addr)
| Set the IP address of this host.
#define | uip_gethostaddr(addr)
| Get the IP address of this host.
#define | uip_input()
| Process an incoming packet.
#define | uip_periodic(conn)
| Periodic processing for a connection identified by its number.
#define | uip_periodic_conn(conn)
| Periodic processing for a connection identified by a pointer to its structure.
#define | uip_udp_periodic(conn)
| Periodic processing for a UDP connection identified by its number.
#define | uip_udp_periodic_conn(conn)
| Periodic processing for a UDP connection identified by a pointer to its structure.
#define | uip_send(data, len)
| Send data on the current connection.
#define | uip_datalen()
| The length of any incoming data that is currently avaliable (if avaliable) in the uip_appdata buffer.
#define | uip_urgdatalen()
| The length of any out-of-band data (urgent data) that has arrived on the connection.
#define | uip_close()
| Close the current connection.
#define | uip_abort()
| Abort the current connection.
#define | uip_stop()
| Tell the sending host to stop sending data.
#define | uip_stopped(conn)
| Find out if the current connection has been previously stopped with uip_stop().
#define | uip_restart()
| Restart the current connection, if is has previously been stopped with uip_stop().
#define | uip_newdata()
| Is new incoming data available?
#define | uip_acked()
| Has previously sent data been acknowledged?
#define | uip_connected()
| Has the connection just been connected?
#define | uip_closed()
| Has the connection been closed by the other end?
#define | uip_aborted()
| Has the connection been aborted by the other end?
#define | uip_timedout()
| Has the connection timed out?
#define | uip_rexmit()
| Do we need to retransmit previously data?
#define | uip_poll()
| Is the connection being polled by uIP?
#define | uip_initialmss()
| Get the initial maxium segment size (MSS) of the current connection.
#define | uip_mss()
| Get the current maxium segment size that can be sent on the current connection.
#define | uip_udp_remove(conn)
| Removed a UDP connection.
#define | uip_udp_send(len)
| Send a UDP datagram of length len on the current connection.
#define | uip_ipaddr(addr, addr0, addr1, addr2, addr3)
| Pack an IP address into a 4-byte array which is used by uIP to represent IP addresses.
#define | HTONS(n)
| Convert 16-bit quantity from host byte order to network byte order.
## Functions
void | uip_init (void)
| uIP initialization function.
void | uip_listen (u16_t port)
| Start listening to the specified port.
void | uip_unlisten (u16_t port)
| Stop listening to the specified port.
uip_conn * | uip_connect (u16_t *ripaddr, u16_t port)
| Connect to a remote host using TCP.
uip_udp_conn * | uip_udp_new (u16_t *ripaddr, u16_t rport)
| Set up a new UDP connection.
u16_t | htons (u16_t val)
| Convert 16-bit quantity from host byte order to network byte order.
## Variables
u8_t | uip_buf [UIP_BUFSIZE+2]
| The uIP packet buffer.
volatile u8_t * | uip_appdata
| Pointer to the application data in the packet buffer.
volatile u8_t | uip_acc32 [4]
| 4-byte array used for the 32-bit sequence number calculations.
uip_stats | uip_stat
| The uIP TCP/IP statistics.